<?php											  
require_once('SuperRecommenderWSProxy.class.php');
require_once('config-entity/entities.include.php');



class RecommenderWSConfigProxy extends SuperRecommenderWSProxy {
	
						
	//Construtor					  
	public function __construct($inWsdlLocal) {
		  $this->wsdlLocal = $inWsdlLocal;
		  $this->soapCli = new soapclient($this->wsdlLocal, true);	 
		  
		  $this->soapCli->soap_defencoding = 'UTF-8'; 	
		  $this->soapCli->decode_utf8 = true;	 
		  
		  $this->proxy = $this->soapCli->getProxy();	
		  
	}
	
	 			   			
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //   Converso de Arrays de Arrays para Array de Objetos (Engine e Parameter)	
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
					
	  private function getEngineArray ($inArray) { 
	  		$outArray = array(); 
			if ((sizeof($inArray)>0)&&(!isset($inArray[0])))	{	
				$engine = new Engine(); 
				$engine->setByArray($inArray); 
				$outArray[0] = $engine;
			} else {			
				for ($i=0;$i<sizeof($inArray);$i++) {	
					$engine = new Engine(); 
					$engine->setByArray($inArray[$i]); 
					$outArray[$i] = $engine;
				} 
			} 
			return $outArray;
	  }
  	  		
	  private function getParameterArray ($inArray) { 
	  		$outArray = array(); 
			if ((sizeof($inArray)>0)&&(!isset($inArray[0])))	{ 
				$parameter = new Parameter(); 
				$parameter->setByArray($inArray);
				$outArray[0] = $parameter; 
			} else {
				for ($i=0;$i<sizeof($inArray);$i++) {	
					$parameter = new Parameter(); 
					$parameter->setByArray($inArray[$i]); 
					$outArray[$i] = $parameter;
				}  
			}
			return $outArray;
	  }
	  	  			
        		

        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        //        Recursos de Instalao dos Engines no RecommenderWS
        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

        public function installEngine ($engineName, $xmlFile, $jarFile) {				 
			if($handle = fopen($jarFile, "r")) {
				$data = fread($handle, filesize($jarFile));
				$jarEncodedFile = base64_encode($data);			
			    fclose($handle);
			 }	
  	         $params = array ("engineName" => $engineName,"xmlFile"=> $xmlFile,"jarEncodedFile"=> $jarEncodedFile);	
			 return $this->checkCall($this->proxy->installEngine($params));
        }
    
        public function getParametersList ($engineName) {	
	        $params = array ("engineName" => $engineName);
			$returnArray = $this->checkCall($this->proxy->getParametersList($params));	
			return $this->getParameterArray($returnArray);         
        }

        public function installedEngines ()  {
			$params = array ();
			$returnArray = $this->checkCall($this->proxy->installedEngines($params));	
			return $this->getEngineArray($returnArray);        
        }
        
        public function getEngineInformation ($engineName)  {  
			$params = array ("engineName" => $engineName);
			$returnArray = $this->checkCall($this->proxy->getEngineInformation($params));
			$engine = new Engine();
			$engine->setByArray($returnArray);
			return $engine;    
        }
        
        
        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        //     Recursos de Configurao dos Engines nas Bibliotecas Digitais
        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
		
        public function activateEngine ($engineName, $dbName) {
	        $params = array ("engineName" => $engineName,"dbName"=> $dbName);	
			return $this->checkCall($this->proxy->activateEngine($params));           
        }

        public function getDefaultEngine ($dbName) {
			$params = array ("dbName"=> $dbName);	
			return $this->checkCall($this->proxy->getDefaultEngine($params));   
        }
		
		public function getActivatedEngines ($dbName) {
			/*
			$params = array ("dbName"=> $dbName);	
			return $this->checkCall($this->proxy->getActivatedEngines($params));
			*/

			$params = array ("dbName"=> $dbName);
			$returnArray = $this->checkCall($this->proxy->getActivatedEngines($params));	
			return $this->getEngineArray($returnArray);       

        }
        
        public function setDefaultEngine ($dbName, $engineClassName) {
	        $params = array ("dbName"=> $dbName, "engineClassName" => $engineClassName);	
			return $this->checkCall($this->proxy->setDefaultEngine($params));           
        }
        
        public function getParameter ($dbName, $engineClassName, $parameter) { 
			$params = array ("dbName"=> $dbName, "engineClassName" => $engineClassName);  
			return $this->checkCall($this->proxy->getParameter($params));   
        }
        
        public function setParameter($dbName, $engineClassName, $parameter, $value) {     
	        $params = array ("dbName"=> $dbName, "engineClassName" => $engineClassName, "parameter" => $parameter, "value"=>$value);	
			return $this->checkCall($this->proxy->setParameter($params));           
        }
        
        public function getParameterValues ($dbName, $engineClassName) {   
			$params = array ("dbName"=> $dbName, "engineClassName" => $engineClassName);	
			$returnArray = $this->checkCall($this->proxy->getParameterValues($params));	
			return $this->getParameterArray($returnArray);   
        }
        
        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        //     Recursos de criao de Bibliotecas Digitais no RecommenderWS
        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            
        public function createDigitalLibrary ($dbName) {
      		$params = array ("dbName"=> $dbName);	
			return $this->checkCall($this->proxy->createDigitalLibrary($params));   
        }
         
        public function configureDigitalLibrary ($dbName, $urlDB, $driver, $user, $password) {
			$params = array ("dbName"=> $dbName,"urlDB"=>$urlDB,"driver"=>$driver,"user"=>$user,"password"=>$password);	
			return $this->checkCall($this->proxy->configureDigitalLibrary($params)); 
        }

	
}

?>