<?php											  
require_once('SuperRecommenderWSProxy.class.php');
require_once('entity/entities.include.php');



class RecommenderWSProxy extends SuperRecommenderWSProxy {

	protected $dbName;					
						
	//Construtor					  
	public function __construct($inWsdlLocal,$inDbName) {
		  $this->dbName = $inDbName;
		  $this->wsdlLocal = $inWsdlLocal;
		  $this->soapCli = new soapclient($this->wsdlLocal, true);
		  $this->proxy = $this->soapCli->getProxy();
	}
	
	
	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //   Converso de Arrays de Arrays para Array de Objetos (User e Item)	
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	 
					
	  private function getUserArray ($inArray) { 
	  		$outArray = array();  
			if ((sizeof($inArray)>0)&&(!isset($inArray[0])))	{	
				$user = new User(); 
				$user->setByArray($inArray); 
				$outArray[0] = $user;
			} else {			
				for ($i=0;$i<sizeof($inArray);$i++) {	
					$user = new User(); 
					$user->setByArray($inArray[$i]); 
					$outArray[$i] = $user;
				} 
			} 
			return $outArray;
	  }
  	  		
	  private function getItemArray ($inArray) { 
	  		$outArray = array(); 
			if ((sizeof($inArray)>0)&&(!isset($inArray[0])))	{ 
				$item = new Item(); 
				$item->setByArray($inArray);
				$outArray[0] = $item; 
			} else {
				for ($i=0;$i<sizeof($inArray);$i++) {	
					$item = new Item(); 
					$item->setByArray($inArray[$i]); 
					$outArray[$i] = $item;
				}  
			}
			return $outArray;
	  }
	  


	  			
	  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	  //        Mtodos de Acesso a Dados
	  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++		 
	  
	  public function insertUser ($user) {
			$params = array ("user" => $user->getArray(), "dbName"=> $this->dbName);
			return $this->checkCall($this->proxy->insertUser($params));
	  }    
    												   
	
      public function insertItem ($item) {
			$params = array ("item" => $item->getArray(), "dbName"=> $this->dbName);
			return $this->checkCall($this->proxy->insertItem($params));
      }
        
      public function insertSerialItem ($item) {
			$params = array ("item" => $item->getArray(), "dbName"=> $this->dbName);
			return $this->checkCall($this->proxy->insertItem($params));
      }
      
	  public function insertRating ($rating) {
			$params = array ("rating" => $rating->getArray(), "dbName"=> $this->dbName);
			return $this->checkCall($this->proxy->insertRating($params));
	  }
            
	  public function getUserById ($userId) {
			$params = array ("userId" => $userId, "dbName"=> $this->dbName);
			$returnArray = $this->checkCall($this->proxy->getUserById($params));
			$user = new User();
			$user->setByArray($returnArray);
			return $user;
	  }
      
      public function getItemById ($itemId) {
			$params = array ("itemId" => $itemId, "dbName"=> $this->dbName);
			$returnArray = $this->checkCall($this->proxy->getItemById($params));
			$item = new Item();
			$item->setByArray($returnArray);
			return $item;
      }

      public function getAllUsers () {
			$params = array ("dbName"=> $this->dbName);	 
			$returnArray = $this->checkCall($this->proxy->getAllUsers($params));	
			return $this->getUserArray($returnArray);
      }
   
      public function getAllItems () {
			$params = array ("dbName"=> $this->dbName);
			$returnArray = $this->checkCall($this->proxy->getAllItems($params));	
			return $this->getItemArray($returnArray);
      }
    
      public function getRatedItems ($userId) {
        	$params = array ("userId" => $userId, "dbName"=> $this->dbName);
			$returnArray = $this->checkCall($this->proxy->getRatedItems($params));	
			return $this->getItemArray($returnArray);
      }
	  
	  
	  
	  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      //        Mtodos de Acesso aos Engines
      //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
	  public function makeModel ($engineClassName) {
        $params = array ("engineClassName" => $engineClassName,"dbName"=> $this->dbName);	
		return $this->checkCall($this->proxy->makeModel($params));

      }
    
    
	  public function getDefaultRecommendationByUser ($user) {
	        $params = array ("user" => $user->getArray(), "dbName"=> $this->dbName);
			$returnArray = $this->checkCall($this->proxy->getDefaultRecommendationByUser($params));	
			return $this->getItemArray($returnArray);        
      }
    
	  public function getDefaultRecommendationByItem ($item) {
	        $params = array ("item" => $item->getArray(), "dbName"=> $this->dbName);
			$returnArray = $this->checkCall($this->proxy->getDefaultRecommendationByItem($params));	
			return $this->getItemArray($returnArray);        
      }
    
	  public function getRecommendationByUser ($user,$engineClassName) {
	        $params = array ("user" => $user->getArray(), "dbName"=> $this->dbName, "engineClassName"=>$engineClassName);
			$returnArray = $this->checkCall($this->proxy->getRecommendationByUser($params));	
			return $this->getItemArray($returnArray);     
      }
    
	  public function getRecommendationByItem ($item,$engineClassName)  {
	        $params = array ("item" => $item->getArray(), "dbName"=> $this->dbName, "engineClassName"=>$engineClassName);
			$returnArray = $this->checkCall($this->proxy->getRecommendationByItem($params));	
			return $this->getItemArray($returnArray);           
      }
        		
      //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      //        OAI: Mtodos importao de Metadados
      //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      
	  public function importRecordList ($url) {
        $params = array ("dbName"=> $this->dbName, "url" => $url);	
		return $this->checkCall($this->proxy->importRecordList($params));
      }
      
   	  public function importRecord ($url, $identifier) {
        $params = array ("dbName"=> $this->dbName, "url" => $url, "identifier" => $identifier);	
		return $this->checkCall($this->proxy->importRecord($params));
      }
}

?>