<?php
require_once('Parameter.class.php');

class Engine {
    
	public function __construct() {			 
		$this->className = ''; 
		$this->engineName = '';
		$this->type	 = '';
		$this->version = '';
		$this->description = '';
		$this->author = '';
		$this->parameters = array();
	}
    
	public function getArray() { 
		$paramArray = array();
		for ($i=0;$i<sizeof($this->parameters);$i++) {	
			$parameter = $this->parameters[$i];			
			$paramArray[$i] = $parameter->getArray();
		}  
		return array ("className" => $this->className, "engineName" => $this->engineName , "type" => $this->type, "version" => $this->version, "description" => $this->description, "author" => $this->author, "parameters" => $paramArray);
	}  

	public function setByArray($inArray) { 
		$this->className = $inArray['className']; 
		$this->engineName = $inArray['engineName'];
		$this->type = $inArray['type'];
		$this->version = $inArray['version'];
		$this->description = $inArray['description'];
		$this->author = $inArray['author'];
		$this->parameters = $this->getParameterArray($inArray['parameters']);
	} 
	
    private function getParameterArray ($inArray) { 
	  		$outArray = array(); 
			if ((sizeof($inArray)>0)&&(!isset($inArray[0])))	{ 
				$parameter = new Parameter(); 
				$parameter->setByArray($inArray);
				$outArray[0] = $parameter; 
			} else {
				for ($i=0;$i<sizeof($inArray);$i++) {	
					$parameter = new Parameter(); 
					$parameter->setByArray($inArray[$i]); 
					$outArray[$i] = $parameter;
				}  
			}
			return $outArray;
	  } 	

    /**
     * Holds value of property className.
     */
    private $className;

    /**
     * Getter for property className.
     * @return Value of property className.
     */
    public function getClassName() {
        return $this->className;
    }

    /**
     * Setter for property className.
     * @param className New value of property className.
     */
    public function setClassName($className) {
        $this->className = $className;
    }

    /**
     * Holds value of property engineName.
     */
    private $engineName;

    /**
     * Getter for property engineName.
     * @return Value of property engineName.
     */
    public function getEngineName() {
        return $this->engineName;
    }

    /**
     * Setter for property engineName.
     * @param engineName New value of property engineName.
     */
    public function setEngineName($engineName) {
        $this->engineName = $engineName;
    }

    /**
     * Holds value of property type.
     */
    private $type;

    /**
     * Getter for property type.
     * @return Value of property type.
     */
    public function getType() {
        return $this->type;
    }

    /**
     * Setter for property type.
     * @param type New value of property type.
     */
    public function setType($type) {
        $this->type = $type;
    }

    /**
     * Holds value of property version.
     */
    private $version;

    /**
     * Getter for property version.
     * @return Value of property version.
     */
    public function getVersion() {
        return $this->version;
    }

    /**
     * Setter for property version.
     * @param version New value of property version.
     */
    public function setVersion($version) {
        $this->version = $version;
    }

    /**
     * Holds value of property description.
     */
    private $description;

    /**
     * Getter for property description.
     * @return Value of property description.
     */
    public function getDescription() {
        return $this->description;
    }

    /**
     * Setter for property description.
     * @param description New value of property description.
     */
    public function setDescription($description) {
        $this->description = $description;
    }

    /**
     * Holds value of property author.
     */
    private $author;

    /**
     * Getter for property author.
     * @return Value of property author.
     */
    public function getAuthor() {
        return $this->author;
    }

    /**
     * Setter for property author.
     * @param author New value of property author.
     */
    public function setAuthor($author) {
        $this->author = $author;
    }

    /**
     * Holds value of property parameters.
     */
    private $parameters;

    /**
     * Getter for property parameters.
     * @return Value of property parameters.
     */
    public function getParameters() {
        return $this->parameters;
    }

    /**
     * Setter for property parameters.
     * @param parameters New value of property parameters.
     */
    public function setParameters($parameters) {
        $this->parameters = $parameters;
    }
    
}
?>